diff --git a/drupal7/sites/all/modules/ctools/tests/math_expression.test b/drupal7/sites/all/modules/ctools/tests/math_expression.test
index b34fafb9..023e46a4 100644
--- a/drupal7/sites/all/modules/ctools/tests/math_expression.test
+++ b/drupal7/sites/all/modules/ctools/tests/math_expression.test
@@ -27,121 +27,308 @@ class CtoolsMathExpressionTestCase extends DrupalWebTestCase {
   }
 
   /**
-   * Returns a random double between 0 and 1.
+   * Return the sign of the numeric arg $n as an integer -1, 0, 1.
+   *
+   * Note: Not defined when $n is Infinity or NaN (or NULL or ...)!
+   *
+   * @param int|float $n
+   *   The number to test.
+   *
+   * @return int
+   *   -1 if the $n is negative, 0 if $n is zero or 1 if $n is positive.
+   *
+   * @see gmp_sign()
+   */
+  protected static function sign($n) {
+    return ($n > 0) - ($n < 0);
+  }
+
+  /**
+   * Returns a random number between 0 and 1.
+   *
+   * @return float
+   *   A random number between 0 and 1 inclusive.
    */
   protected function rand01() {
-    return rand(0, PHP_INT_MAX) / PHP_INT_MAX;
+    return mt_rand(0, PHP_INT_MAX) / PHP_INT_MAX;
   }
 
   /**
    * A custom assertion with checks the values in a certain range.
+   *
+   * @param float $first
+   *   A value to check for equality.
+   * @param float $second
+   *   A value to check for equality.
+   * @param string $message
+   *   The message describing the correct behaviour, eg. "2/4 equals 1/2". The
+   *   default message is used if this value is empty.
+   * @param float $delta
+   *   The precision with which values must match. This accounts for rounding
+   *   errors and imprecise representation errors in the floating point format.
+   *   The value passed in should ideally be proportional to the values being
+   *   compared.
+   * @param string $group
+   *   Which group this assert belongs to.
+   *
+   * @return bool
+   *   TRUE if the assertion was correct (that is, $first == $second within the
+   *   given limits), FALSE otherwise.
    */
-  protected function assertFloat($first, $second, $delta = 0.0000001, $message = '', $group = 'Other') {
-    return $this->assert(abs($first - $second) <= $delta, $message ? $message : t('Value @first is equal to value @second.', array('@first' => var_export($first, TRUE), '@second' => var_export($second, TRUE))), $group);
+  protected function assertFloat($first, $second, $message = '', $delta = 0.00000001, $group = 'Other') {
+    // Check for NaN and Inf because the abs() and sign() code won't like those.
+    $equal = FALSE
+      // Equal if both an infinity.
+      || (is_infinite($first) && is_infinite($second))
+
+      // Equal if both NaN.
+      || (is_nan($first) && is_nan($second))
+
+      // Equal if same absolute value (within limits) and same sign.
+      || ((abs($first - $second) <= $delta) && (self::sign($first) === self::sign($second)));
+
+    if (empty($message)) {
+      $default = t('Value !first is equal to value !second.',
+        array(
+          '!first' => var_export($first, TRUE),
+          '!second' => var_export($second, TRUE),
+        ));
+      $message = $default;
+    }
+
+    return $this->assert($equal, $message, $group);
   }
 
   /**
    * Test some arithmetic handling.
    */
   public function testArithmetic() {
-    $math_expression = new ctools_math_expr();
-
-    // Test constant expressions.
-    $this->assertEqual($math_expression->e('2'), 2);
-    $random_number = rand(0, 10);
-    $this->assertEqual($random_number, $math_expression->e((string) $random_number));
-
-    // Test simple arithmetic.
-    $random_number_a = rand(5, 10);
-    $random_number_b = rand(5, 10);
-    $this->assertEqual($random_number_a + $random_number_b, $math_expression->e("$random_number_a + $random_number_b"));
-    $this->assertEqual($random_number_a - $random_number_b, $math_expression->e("$random_number_a - $random_number_b"));
-    $this->assertEqual($random_number_a * $random_number_b, $math_expression->e("$random_number_a * $random_number_b"));
-    $this->assertEqual($random_number_a / $random_number_b, $math_expression->e("$random_number_a / $random_number_b"));
-
-    // Test Associative property.
-    $random_number_c = rand(5, 10);
-    $this->assertEqual($math_expression->e("$random_number_a + ($random_number_b + $random_number_c)"), $math_expression->e("($random_number_a + $random_number_b) + $random_number_c"));
-    $this->assertEqual($math_expression->e("$random_number_a * ($random_number_b * $random_number_c)"), $math_expression->e("($random_number_a * $random_number_b) * $random_number_c"));
-
-    // Test Commutative property.
-    $this->assertEqual($math_expression->e("$random_number_a + $random_number_b"), $math_expression->e("$random_number_b + $random_number_a"));
-    $this->assertEqual($math_expression->e("$random_number_a * $random_number_b"), $math_expression->e("$random_number_b * $random_number_a"));
-
-    // Test Distributive property.
-    $this->assertEqual($math_expression->e("($random_number_a + $random_number_b) * $random_number_c"), $math_expression->e("($random_number_a * $random_number_c + $random_number_b * $random_number_c)"));
-
-    $this->assertEqual(pow($random_number_a, $random_number_b), $math_expression->e("$random_number_a ^ $random_number_b"));
+    $math_expr = new ctools_math_expr();
+
+    $this->assertEqual($math_expr->evaluate('2'), 2, 'Check Literal 2');
+
+    $this->assertEqual($math_expr->e('2+1'), $math_expr->evaluate('2+1'), 'Check that e() and evaluate() are equivalent.');
+
+    foreach (range(1, 4) as $n) {
+      // Test constant expressions.
+      $random_number = mt_rand(0, 20);
+      $this->assertEqual($random_number, $math_expr->evaluate((string) $random_number), "Literal $random_number");
+
+      // Test simple arithmetic.
+      $number_a = mt_rand(-55, 777);
+      $number_b = mt_rand(-555, 77);
+      $this->assertEqual(
+        $number_a + $number_b,
+        $math_expr->evaluate("$number_a + $number_b"),
+        "Addition: $number_a + $number_b");
+      $this->assertEqual(
+        $number_a - $number_b,
+        $math_expr->evaluate("$number_a - $number_b"),
+        "Subtraction: $number_a + $number_b");
+      $this->assertFloat(
+        ($number_a * $number_b),
+        $math_expr->evaluate("$number_a * $number_b"),
+        "Multiplication: $number_a * $number_b = " . ($number_a * $number_b));
+      $this->assertFloat(
+        ($number_a / $number_b),
+        $math_expr->evaluate("$number_a / $number_b"),
+        "Division: $number_a / $number_b = " . ($number_a / $number_b));
+
+      // Test Associative property.
+      $number_c = mt_rand(-99, 77);
+      $this->assertEqual(
+        $math_expr->evaluate("$number_a + ($number_b + $number_c)"),
+        $math_expr->evaluate("($number_a + $number_b) + $number_c"),
+        "Associative: $number_a + ($number_b + $number_c)");
+      $this->assertEqual(
+        $math_expr->evaluate("$number_a * ($number_b * $number_c)"),
+        $math_expr->evaluate("($number_a * $number_b) * $number_c"),
+        "Associative: $number_a * ($number_b * $number_c)");
+
+      // Test Commutative property.
+      $this->assertEqual(
+        $math_expr->evaluate("$number_a + $number_b"),
+        $math_expr->evaluate("$number_b + $number_a"),
+        "Commutative: $number_a + $number_b");
+      $this->assertEqual(
+        $math_expr->evaluate("$number_a * $number_b"),
+        $math_expr->evaluate("$number_b * $number_a"),
+        "Commutative: $number_a * $number_b");
+
+      // Test Distributive property.
+      $this->assertEqual(
+        $math_expr->evaluate("($number_a + $number_b) * $number_c"),
+        $math_expr->evaluate("($number_a * $number_c + $number_b * $number_c)"),
+        "Distributive: ($number_a + $number_b) * $number_c");
+
+      // @todo: Doesn't work with zero or negative powers when number is zero or negative, e.g. 0^0, 0^-2, -2^0, -2^-2.
+      $random_number = mt_rand(1, 15);
+      $random_power = mt_rand(-15, 15);
+
+      $this->assertFloat(
+        pow($random_number, $random_power),
+        $math_expr->evaluate("$random_number ^ $random_power"),
+        "$random_number ^ $random_power");
+
+      $this->assertFloat(
+        pow($random_number, $random_power),
+        $math_expr->evaluate("pow($random_number, $random_power)"),
+        "pow($random_number, $random_power)");
+    }
   }
 
   /**
-   * Test the basic built-in functions in the math expression library.
+   * Test various built-in transcendental and extended functions.
    */
   public function testBuildInFunctions() {
-    $math_expression = new ctools_math_expr();
-
-    // @todo Maybe run this code multiple times to test different values.
-    $random_double = $this->rand01();
-    $random_int = rand(5, 10);
-    $this->assertFloat(sin($random_double), $math_expression->e("sin($random_double)"));
-    $this->assertFloat(cos($random_double), $math_expression->e("cos($random_double)"));
-    $this->assertFloat(tan($random_double), $math_expression->e("tan($random_double)"));
-    $this->assertFloat(exp($random_double), $math_expression->e("exp($random_double)"));
-    $this->assertFloat(sqrt($random_double), $math_expression->e("sqrt($random_double)"));
-    $this->assertFloat(log($random_double), $math_expression->e("ln($random_double)"));
-    $this->assertFloat(round($random_double), $math_expression->e("round($random_double)"));
-    $this->assertFloat(abs($random_double + $random_int), $math_expression->e('abs(' . ($random_double + $random_int) . ')'));
-    $this->assertEqual(round($random_double + $random_int), $math_expression->e('round(' . ($random_double + $random_int) . ')'));
-    $this->assertEqual(ceil($random_double + $random_int), $math_expression->e('ceil(' . ($random_double + $random_int) . ')'));
-    $this->assertEqual(floor($random_double + $random_int), $math_expression->e('floor(' . ($random_double + $random_int) . ')'));
-
-    // @fixme: you can't run time without an argument.
-    $this->assertFloat(time(), $math_expression->e('time(1)'));
+    $math_expr = new ctools_math_expr();
+
+    foreach (range(1, 4) as $n) {
+      $random_double = $this->rand01();
+      $random_int = mt_rand(-65535, 65535);
+      $this->assertFloat(sin($random_double), $math_expr->evaluate("sin($random_double)"), "sin($random_double)");
+      $this->assertFloat(cos($random_double), $math_expr->evaluate("cos($random_double)"), "cos($random_double)");
+      $this->assertFloat(tan($random_double), $math_expr->evaluate("tan($random_double)"), "tan($random_double)");
+      $this->assertFloat(exp($random_double), $math_expr->evaluate("exp($random_double)"), "exp($random_double)");
+      $this->assertFloat(sqrt($random_double), $math_expr->evaluate("sqrt($random_double)"), "sqrt($random_double)");
+      $this->assertFloat(log($random_double), $math_expr->evaluate("ln($random_double)"), "ln($random_double)");
+      $this->assertFloat(round($random_double), $math_expr->evaluate("round($random_double)"), "round($random_double)");
+
+      $random_real = $random_double + $random_int;
+      $this->assertFloat(abs($random_real), $math_expr->evaluate('abs(' . $random_real . ')'), "abs($random_real)");
+      $this->assertEqual(round($random_real), $math_expr->evaluate('round(' . $random_real . ')'), "round($random_real)");
+      $this->assertEqual(ceil($random_real), $math_expr->evaluate('ceil(' . $random_real . ')'), "ceil($random_real)");
+      $this->assertEqual(floor($random_real), $math_expr->evaluate('floor(' . $random_real . ')'), "floor($random_real)");
+    }
+
+    $this->assertFloat(time(), $math_expr->evaluate('time()'), "time()");
 
     $random_double_a = $this->rand01();
     $random_double_b = $this->rand01();
-    // @fixme: max/min don't work at the moment.
-//    $this->assertFloat(max($random_double_a, $random_double_b), $math_expression->e("max($random_double_a, $random_double_b)"));
-//    $this->assertFloat(min($random_double_a, $random_double_b), $math_expression->e("min($random_double_a, $random_double_b)"));
+    $this->assertFloat(
+      max($random_double_a, $random_double_b),
+      $math_expr->evaluate("max($random_double_a, $random_double_b)"),
+      "max($random_double_a, $random_double_b)");
+    $this->assertFloat(
+      min($random_double_a, $random_double_b),
+      $math_expr->evaluate("min($random_double_a, $random_double_b)"),
+      "min($random_double_a, $random_double_b)");
   }
 
   /**
    * Test variable handling.
    */
   public function testVariables() {
-    $math_expression = new ctools_math_expr();
+    $math_expr = new ctools_math_expr();
+
+    // We should have a definition of pi:
+    $this->assertFloat(pi(), $math_expr->evaluate('pi'));
+
+    // And a definition of e:
+    $this->assertFloat(exp(1), $math_expr->evaluate('e'));
+
+    $number_a = 5;
+    $number_b = 10;
+
+    // Store the first number and use it on a calculation.
+    $math_expr->evaluate("var = $number_a");
+    $this->assertEqual($number_a + $number_b, $math_expr->evaluate("var + $number_b"));
 
-    $random_number_a = rand(5, 10);
-    $random_number_b = rand(5, 10);
+    // Change the value and check the new value is used.
+    $math_expr->evaluate("var = $number_b");
+    $this->assertEqual(
+      $number_b + $number_b,
+      $math_expr->evaluate("var + $number_b"),
+      "var + $number_b");
 
-    // Store the first random number and use it on calculations.
-    $math_expression->e("var = $random_number_a");
-    $this->assertEqual($random_number_a + $random_number_b, $math_expression->e("var + $random_number_b"));
-    $this->assertEqual($random_number_a * $random_number_b, $math_expression->e("var * $random_number_b"));
-    $this->assertEqual($random_number_a - $random_number_b, $math_expression->e("var - $random_number_b"));
-    $this->assertEqual($random_number_a / $random_number_b, $math_expression->e("var / $random_number_b"));
+    // Store another number and use it on a calculation.
+    $math_expr->evaluate("var = $number_a");
+    $math_expr->evaluate("newvar = $number_a");
+
+    $this->assertEqual(
+      $number_a + $number_a,
+      $math_expr->evaluate('var + newvar'),
+      'var + newvar');
+
+    $this->assertFloat(
+      $number_a / $number_b,
+      $math_expr->evaluate("var / $number_b"),
+      "var / $number_b");
   }
 
   /**
    * Test custom function handling.
    */
   public function testCustomFunctions() {
-    $math_expression = new ctools_math_expr();
+    $math_expr = new ctools_math_expr();
 
-    $random_number_a = rand(5, 10);
-    $random_number_b = rand(5, 10);
+    $number_a = mt_rand(5, 10);
+    $number_b = mt_rand(5, 10);
 
     // Create a one-argument function.
-    $math_expression->e("f(x) = 2 * x");
-    $this->assertEqual($random_number_a * 2, $math_expression->e("f($random_number_a)"));
-    $this->assertEqual($random_number_b * 2, $math_expression->e("f($random_number_b)"));
+    $math_expr->evaluate("f(x) = 2 * x");
+    $this->assertEqual($number_a * 2, $math_expr->evaluate("f($number_a)"));
+    $this->assertEqual($number_b * 2, $math_expr->evaluate("f($number_b)"));
 
     // Create a two-argument function.
-    $math_expression->e("g(x, y) = 2 * x + y");
-    $this->assertEqual($random_number_a * 2 + $random_number_b, $math_expression->e("g($random_number_a, $random_number_b)"));
+    $math_expr->evaluate("g(x, y) = 2 * x + y");
+    $this->assertEqual(
+      $number_a * 2 + $number_b,
+      $math_expr->evaluate("g($number_a, $number_b)"),
+      "g($number_a, $number_b)");
 
     // Use a custom function in another function.
-    $this->assertEqual(($random_number_a * 2 + $random_number_b) * 2, $math_expression->e("f(g($random_number_a, $random_number_b))"));
+    $this->assertEqual(
+      ($number_a * 2 + $number_b) * 2,
+      $math_expr->evaluate("f(g($number_a, $number_b))"),
+      "f(g($number_a, $number_b))");
+  }
+
+  /**
+   * Test conditional handling.
+   */
+  public function testIf() {
+    $math_expr = new ctools_math_expr();
+
+    $number_a = mt_rand(1, 10);
+    $number_b = mt_rand(11, 20);
+
+    foreach (range(1, 4) as $n) {
+      // @todo: Doesn't work with negative numbers.
+      if ($n == 2 || $n == 4) {
+        //$number_a = -$number_a;
+      }
+
+      if ($n == 3 || $n == 4) {
+        //$number_b = -$number_b;
+      }
+
+      $this->assertEqual(
+        $number_a,
+        $math_expr->evaluate("if(1, $number_a, $number_b)"),
+        "if(1, $number_a, $number_b)");
+
+      $this->assertEqual(
+        $number_a,
+        $math_expr->evaluate("if(1, $number_a)",
+          "if(1, $number_a)"));
+
+      $this->assertEqual(
+        $number_b,
+        $math_expr->evaluate("if(0, $number_a, $number_b)"),
+        "if(0, $number_a, $number_b)");
+
+      // Also add an expression so ensure it's evaluated.
+      $this->assertEqual(
+        $number_b,
+        $math_expr->evaluate("if($number_a > $number_b, $number_a, $number_b)"),
+        "if($number_a > $number_b, $number_a, $number_b)");
+
+      $this->assertEqual(
+        $number_b,
+        $math_expr->evaluate("if($number_a < $number_b, $number_b, $number_a)"),
+        "if($number_a < $number_b, $number_b, $number_a)");
+    }
   }
 
 }
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
index 9ad7728f..0754d426 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views.inc
@@ -173,7 +173,7 @@ function views_content_views_content_type_render($subtype, $conf, $panel_args, $
       if ($conf['use_pager'] && ($pager['type'] == 'none' || $pager['type'] == 'some')) {
         $pager['type'] = 'full';
       }
-      elseif (!$conf['use_pager'] && $pager['type'] != 'none' && $pager['type'] != 'some') {
+      elseif (!$conf['use_pager']) {
         $pager['type'] = $view->get_items_per_page() ? 'some' : 'none';
       }
 
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
index 07e93f7a..afc98136 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_panes.inc
@@ -254,7 +254,7 @@ function views_content_views_panes_content_type_render($subtype, $conf, $panel_a
     if ($conf['use_pager'] && ($pager['type'] == 'none' || $pager['type'] == 'some')) {
       $pager['type'] = 'full';
     }
-    elseif (!$conf['use_pager'] && $pager['type'] != 'none' && $pager['type'] != 'some') {
+    elseif (!$conf['use_pager']) {
       $pager['type'] = $view->get_items_per_page() || !empty($pager['options']['items_per_page']) ? 'some' : 'none';
     }
 
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_row.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_row.inc
index 16b97dc7..6678f447 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_row.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/content_types/views_row.inc
@@ -228,8 +228,9 @@ function views_content_views_row_content_type_admin_info($subtype, $conf, $conte
 
 function views_content_views_row_content_type_admin_title($subtype, $conf, $context) {
   $rows = array_filter($conf['rows']);
+  $row_count = count($rows);
   $rows = empty($rows) ? t('Show all') : implode(', ', $rows);
-  return format_plural(count($rows),
+  return format_plural($row_count,
     '"@context" row @rows',
     '"@context" rows @rows',
     array('@context' => $context->identifier, '@rows' => $rows)
diff --git a/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc b/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc
index 05d3478f..801d3d61 100644
--- a/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc
+++ b/drupal7/sites/all/modules/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc
@@ -4,6 +4,7 @@
  * The plugin that handles a panel_pane.
  */
 class views_content_plugin_display_panel_pane extends views_plugin_display {
+
   /**
    * If this variable is true, this display counts as a panel pane. We use
    * this variable so that other modules can create alternate pane displays.
@@ -11,7 +12,9 @@ class views_content_plugin_display_panel_pane extends views_plugin_display {
   public $panel_pane_display = TRUE;
   public $has_pane_conf = NULL;
 
-
+  /**
+   * {@inheritdoc}
+   */
   public function option_definition() {
     $options = parent::option_definition();
 
@@ -382,7 +385,31 @@ class views_content_plugin_display_panel_pane extends views_plugin_display {
     return (bool) $conf['more_link'];
   }
 
+  /**
+   * {@inheritdoc}
+   */
+  public function has_path() {
+    return TRUE;
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  public function validate() {
+    // To bypass the validation of the path from Views we temporarily
+    // override the path if one doesn't exist because it will be generated
+    // by panels though we want the rest of the validations to run.
+    $path = $this->get_path();
+    if (!$path) {
+      $this->set_option('path', $_GET['q']);
+    }
+
+    return parent::validate();
+  }
 
+  /**
+   * {@inheritdoc}
+   */
   public function get_path() {
     if (empty($this->view->override_path)) {
       return parent::get_path();
diff --git a/drupal7/sites/all/modules/ctools/views_content/views_content.info b/drupal7/sites/all/modules/ctools/views_content/views_content.info
index 68f4d875..9b348c52 100644
--- a/drupal7/sites/all/modules/ctools/views_content/views_content.info
+++ b/drupal7/sites/all/modules/ctools/views_content/views_content.info
@@ -9,8 +9,8 @@ files[] = plugins/views/views_content_plugin_display_ctools_context.inc
 files[] = plugins/views/views_content_plugin_display_panel_pane.inc
 files[] = plugins/views/views_content_plugin_style_ctools_context.inc
 
-; Information added by Drupal.org packaging script on 2019-02-08
-version = "7.x-1.15"
+; Information added by Drupal.org packaging script on 2020-10-23
+version = "7.x-1.17"
 core = "7.x"
 project = "ctools"
-datestamp = "1549603691"
+datestamp = "1603490551"
